﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using Ares.IO;
using Ares.Protocol;

namespace arca4
{
    class MOTD
    {
        private static List<String> motd;

        public static void SendMOTD(UserObject userobj)
        {
            List<byte> buf = new List<byte>();

            motd.ForEach(x =>
            {
                buf.AddRange(AresTCPPackets.NoSuch(x.Replace("+n", userobj.Name).Replace("+ip", userobj.ExternalIP.ToString()).Replace("+v", userobj.Version)));

                if (buf.Count > 800)
                {
                    userobj.SendPacket(AresTCPPackets.ClientCompressed(buf.ToArray()));
                    buf.Clear();
                }
            });

            if (buf.Count > 0)
                userobj.SendPacket(AresTCPPackets.ClientCompressed(buf.ToArray()));
        }

        public static void LoadMOTD()
        {
            motd = new List<String>();

            String path = Environment.GetFolderPath(System.Environment.SpecialFolder.ApplicationData);
            path = Path.Combine(path, "Arca4");

            if (!Directory.Exists(path))
                Directory.CreateDirectory(path);

            path = Path.Combine(path, "motd.txt");

            if (File.Exists(path))
            {
                try
                {
                    motd.AddRange(File.ReadAllLines(path));
                }
                catch { motd.Add("Welcome to my room +n"); }
            }
            else
            {
                motd.Add("Welcome to my room +n");

                try
                {
                    File.WriteAllLines(path, motd.ToArray(), Encoding.UTF8);
                }
                catch { }
            }
        }
    }
}
