﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography;
using smnetjs;

namespace arca4.Scripting.JS
{
	[SMEmbedded(Name="Arca4BannedUser", AllowInheritedMembers=false)]
	class BannedUserObj
	{
		private UserRecordItem banItem = null;


		internal UserRecordItem InternalUserRecord
		{
			get { return banItem; }
		}
		
		[SMIgnore]
		public BannedUserObj(UserRecordItem item)
		{
			banItem = item;
		}

		[SMProperty(Name="name")]
		public String Name { get { return banItem.Name; } }

		[SMProperty(Name = "version")]
		public String Version { get { return banItem.Version; } }

		[SMProperty(Name = "guid")]
		public string Guid
		{
			get
			{
				return Convert.ToBase64String(SHA1.Create().ComputeHash(banItem.Guid.ToByteArray()));
			}
		}

		[SMProperty(Name = "externalIp")]
		public string ExternalIP { get { return banItem.ExternalIP.ToString(); } }

		[SMProperty(Name = "localIp")]
		public string LocalIP { get { return banItem.LocalIP.ToString(); } }

		[SMProperty(Name = "port")]
		public ushort Port { get { return banItem.Port; } }

		[SMProperty(Name = "time")]
		public uint Time { get { return Helpers.UnixTime - banItem.Time; } }



	}
}
