﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ares.Protocol;

namespace arca4.Scripting.JS
{
    static class Server
    {
        public static string topic
        {
            get { return Settings.Topic; }
            set
            {
                Settings.Topic = value;
                UserPool.Broadcast(AresTCPPackets.Topic(value));
            }
        }

        public static string name
        {
            get { return Settings.Name; }
        }

        public static string botName
        {
            get { return Settings.BotName; }
        }

        public static string version
        {
            get { return Settings.Version; }
        }

        public static string externalIp
        {
            get { return Settings.ExternalIP.ToString(); }
        }

        public static string localIp
        {
            get { return Settings.LocalIP.ToString(); }
        }

        public static int port
        {
            get { return Settings.Port; }
        }

        public static int banLevel
        {
            get { return Settings.BanLevel; }
        }

        public static int killLevel
        {
            get { return Settings.KillLevel; }
        }

        public static int muzzleLevel
        {
            get { return Settings.MuzzleLevel; }
        }

        public static int scriptLevel
        {
            get { return Settings.ScriptLevel; }
        }

        public static bool loadMotd()
        {
            MOTD.LoadMOTD();
            return true;
        }

        public static void viewMotd(UserObj userobj)
        {
            if (userobj != null)
                if (userobj.InternalUserObject != null)
                    MOTD.SendMOTD(userobj.InternalUserObject);
        }

        public static bool clearBans()
        {
            Bans.Clear();
            Muzzles.Clear();
            return true;
        }
    }
}
