﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SQLite;
using smnetjs;

namespace arca4.Scripting.JS
{
    [SMEmbedded(AllowInheritedMembers = false)]
    class SqlQuery
    {
        private List<SQLiteParameter> _params = new List<SQLiteParameter>();

        internal SQLiteParameter this[int index]
        {
            get { return this._params[index]; }
        }

        internal int length
        {
            get { return this._params.Count; }
        }

        internal String query { get; private set; }

        public SqlQuery(String query, params object[] args)
        {
            this.query = query;
            int counter = 0;

            for (int i = 0; i < args.Length; i++)
            {
                if (!this.query.Contains("{" + counter + "}"))
                    throw new Exception("invalid query format");

                this.query = this.query.Replace("{" + counter + "}", "@var" + counter);

                if (args[i] is string)
                    this._params.Add(new SQLiteParameter(("@var" + (counter++)), (string)args[i]));
                else if (args[i] is int)
                    this._params.Add(new SQLiteParameter(("@var" + (counter++)), (int)args[i]));
            }
        }
    }
}
